use_inline_resources

include Chef::DSL::IncludeRecipe

action :create do
  include_recipe "conffile"

  case new_resource.environment
  when "system"
    name = "hgrc for system"
    current_path = system_path
    directory ::File.dirname(current_path) do
      mode "0755"
      recursive true
    end
  when "user"
    name = "hgrc for user #{new_resource.user}"
    current_path = user_path
  when "repo"
    name = "hgrc for repo #{new_resource.path}"
    current_path = repo_path
  else
    log "not supported" do
      level :error
    end
  end

  conffile_ini name do
    parameters new_resource.parameters
    path current_path
    separator "="
    comment "#"
  end
end

def system_path
  if node['os'] == "windows"
    raise "windows not supported"
  else
    return "/etc/mercurial/hgrc.d/chef.rc"
  end
end

def user_path
  return ::Dir.home(new_resource.user)
end

def repo_path
  return ::File.join(new_resource.path, ".hg", "hgrc")
end
